/**
 * A very rudimentary sorted list class (ie not general purpose -
 * implements only the functionality needed here!) The objects to be
 * stored must be Sortable-interface implementations. This interface
 * defines the method which is used to sort the objects, compareTo.
 */
public class SortedList {

	protected class Item {
		// 
		// Item is used to store the Sortables of the list
		// and to link them together
		//
		public Sortable content;

		public Item next;

		public Item(Sortable aContent, Item aNext) {
			content = aContent;
			next = aNext;
		} /* Item */

		public Item(Sortable aContent) {
			this(aContent, null);
		} /* Item */

	} /* Item */

	protected static Sortable lastSorter = new Sortable() {
		//
		// a guard Sortable for the linked circular list used;
		// lastSorter deems itself "greater than" any other Sortable,
		// therefore it is always the "last" item in the list
		//
		public int compareTo(Sortable s) {
			return 1; // ie, this > s
		} /* compareTo */
	}; /* lastSorter */

	protected Item last; // the anchor of the circular list

	private Item current; // current is used by getFirst() and getNext()

	protected int number; // number of elements in the list

	public SortedList() {
		// use a linked circular list with lastSorter as the
		// content of the "last" object in the list
		last = new Item(lastSorter);
		last.next = last;
		current = last;
		number = 0;
	} /* SortedList */

	public void insert(Sortable s, boolean equalsAtBegin) {
		Item current = last;
		if (equalsAtBegin)
			while (current.next.content.compareTo(s) < 0)
				current = current.next;
		else
			while (current.next.content.compareTo(s) <= 0)
				current = current.next;

		current.next = new Item(s, current.next);
		number++;
	} /* insert */

	public Sortable removeFirst() {
		Sortable s = last.next.content;
		last.next = last.next.next;
		number--;
		return s;
	} /* removeFirst */

	public boolean empty() {
		return last.next == last;
	} /* empty */

	public Sortable getFirst() {
		current = last.next;
		return (current == last) ? null : current.content;
	} /* getFirst */

	public Sortable getNext() {
		current = current.next;
		return (current == last) ? null : current.content;
	} /* getNext */

	public int count() {
		return number;
	} /* count */

} /* SortedList */

